#include "stdafx.h"
#include ".\adapterwindow.h"

CAdapterWindow::CAdapterWindow(void)
{
	m_bTracking = FALSE;
}

CAdapterWindow::~CAdapterWindow(void)
{
}
BOOL CAdapterWindow::Create(HWND hWndParent)
{
	ATLASSERT(hWndParent!=NULL);

	m_rootContainer.SetOwner(hWndParent);		
	return TRUE;
}
void CAdapterWindow::MoveWindow(int nX, int nY, int nWidth, int nHeight)
{
	m_rootContainer.MoveWindow(nX, nY, nWidth, nHeight);
}
void CAdapterWindow::Draw(HDC hDC)
{
	CRect rcContainer;
	m_rootContainer.GetBounds(&rcContainer);
	
	//FillSolidRect(hDC, rcContainer.left, rcContainer.top, rcContainer.Width(), rcContainer.Height(), RGB(0xff, 0x0, 0xff));

	POINT ptOrg = {0, 0};	
	BOOL bChangeViewport = FALSE;
	
	bChangeViewport = OffsetViewportOrgEx(hDC, rcContainer.left, rcContainer.top, &ptOrg);

	m_rootContainer.OnDraw(hDC);
	if (bChangeViewport)
	{
		SetViewportOrgEx(hDC, ptOrg.x, ptOrg.y, NULL);
	}
}/*
IMPLEMENT_MESSAGE_HANDLER_REF(CAdapterWindow, OnMouseEvent)
{
	CPoint ptMouse(lParam);
	CRect rcContainer;
	m_rootContainer.GetBounds(&rcContainer);
	ptMouse.Offset(rcContainer.TopLeft());

	//lParam = MAKELPARAM(ptMouse.x, ptMouse.y);
	bHandled = FALSE;
	return 0;
}*/
IMPLEMENT_MESSAGE_HANDLER(CAdapterWindow, OnMouseMove)
{ 
	if(m_bTracking)
	{

	}	
	else
	{
		TRACKMOUSEEVENT TrackEvent;
		TrackEvent.cbSize      = sizeof( TRACKMOUSEEVENT );
		TrackEvent.dwFlags     = TME_LEAVE;
		TrackEvent.hwndTrack   = m_rootContainer.GetOwner();
		TrackEvent.dwHoverTime = 1;
		m_bTracking = TrackMouseEvent( &TrackEvent );
	}
	bHandled = FALSE;
	return 0;
}
IMPLEMENT_MESSAGE_HANDLER(CAdapterWindow, OnMouseLeave)
{
	m_bTracking = FALSE;
	m_rootContainer.MouseAway();
	return 0;
}